%C1data = [xlsread('MFile1','K2SO4','A2:A17')' xlsread('MFile1','K2SO4','A2:A17')' xlsread('MFile1','K2SO4','A2:A17')']*1000;%mM %cp
C1data = logspace(-5,5,30);
C2overC1 = 5.*C1data;%cf
R = 8.314; % 8.314 J/mol K
F = 1.609e-19*6.022e23; % C/mol
T = 298;
Z2=1;
Z1=2;
%D1 = [1.957e-9];%*ones(1,16) 1.957e-9*ones(1,16) 1.957e-9*ones(1,16)];% K diffusivity
%D1 = [0.792e-9];%*ones(1,16) 0.792e-9*ones(1,16) 0.792e-9*ones(1,16)]; %Ca diffusivity
%D1 = [0.706e-9];%*ones(1,16) 0.706e-9*ones(1,16) 0.706e-9*ones(1,16)];% Mg diffusivit
D1= [0.714e-9];% Cu
%D2 = [1.065e-9];%*ones(1,16) 1.065e-9*ones(1,16) 1.065e-9*ones(1,16)];%SO4 diffusivity
D2 = [2.032e-9];%*ones(1,16) 2.032e-9*ones(1,16) 2.032e-9*ones(1,16)];% Cl 
t1=Z1.*D1./(Z1.*D1+Z2.*D2);
tr=C1data./C2overC1;
v1=1; %stoichiometric coefficient of the electrolyte
Cr=10;% Xm in the paper
ep=(Cr./C1data)./Z1./v1;
ef= (Cr./C2overC1)./Z1./v1;
alpha=1;
%lambdap=108+12*sqrt(3).*sqrt(27-4.*(ep).^3);
%gammap= (((lambdap.^(1/3))/6)+((2.*ep)./(lambdap).^(1/3))).^(+1);
%kp=(gammap).^(-1);
theta=acos (0.5.*(ep./3).^-1.5);
gammap = 2*(sqrt(ep./3)).*cos(theta/3);
kp=(gammap).^(-1);
%lambdaf=108+12*sqrt(3).*sqrt(27-4.*(ef).^3);
%gammaf= (((lambdaf.^(1/3))/6)+((2.*ef)./(lambdaf).^(1/3))).^(+1);
%kf=(gammaf).^(-1);
theta=acos (0.5.*(ef./3).^-1.5);
gammaf = 2*(sqrt(ef./3)).*cos(theta/3);
kf=(gammaf).^(-1);
Donnan = (1/Z2)*log(kp./kf);
Diffusion =((D1-D2)/((Z2*D2)+(Z1*D1)))*log((tr.*kp+t1.*ef)./(kf+t1.*ef));
%Diffusion =((R*T)/F)*log((tr.*kp+t1.*ef)./(kf+t1.*ef));
deltaPhi1 = ((R*T)/F)*(alpha*Donnan+Diffusion);
datacursormode on
semilogx(C1data,-deltaPhi1,'o');
-deltaPhi1'
format long 
C1data'
%semilogx(C1data,Donnan,'^');
%semilogx(C1data,Donnan,'^',C1data,Diffusion,'o')